# Flatpack

**NOTE:** Flatpack is currently experimental. Please refrain from using it in production environments.

## Ready-to-assemble AI

Welcome, brave explorer! We are still in stealth mode (of sorts), but we are glad you found us.

Flatpack democratises AI and ML through micro language models and model compression. Our platform enables users to train
customised models with 10M to 10B parameters. We introduce flatpacks (FPKs) to integrate AI and ML into edge computing,
electronic components, and robots.

## Flatpack 3.X.X (Aglaonice)

*Aglaonice, an ancient Greek astronomer from the 2nd or 1st century BC, was celebrated for her precise lunar eclipse
predictions. Her mastery inspired the Greek proverb: "As the moon obeys Aglaonice," signifying unwavering certainty.*

`3.3.0` (2024-04-16)\
*Added a vector database for storing and querying embeddings.*

`3.2.0` (2024-03-09)\
*Added support for unboxing local flatpacks using --local.*

`3.1.0` (2023-12-11)\
*Introduced a local web interface for a better user experience.*

`3.0.0` (2023-10-20)\
*Moved to a predictable and structured release strategy.*

## Moving to versioning structure: 3.0.0

Our previous releases were a mix of minor tweaks and significant shifts, making it challenging to anticipate the nature
of changes. With the introduction of version 3.0.0, we are embracing a predictable and structured release strategy:

- **Major versions** (`X.0.0`): These signify significant changes or updates.
- **Minor versions** (`3.X.0`): Introduce new features without breaking compatibility.
- **Patch versions** (`3.0.X`): Address bug fixes and minor refinements.

This move is not merely about [semantic versioning](https://semver.org/). It is a pledge for clear communication and
trust with our users. We invite you to explore our new release strategy and appreciate your patience as we evolve.

[Explore the Project on GitHub](https://github.com/romlingroup/flatpack-ai)

## License

This project is released under [Apache-2.0](https://github.com/romlingroup/flatpack-ai/blob/main/LICENSE).

## install_requires

BSD-3-Clause (INBOUND) is compatible with Apache-2.0 (OUTBOUND) for combined works but does not allow re-licensing of
the original BSD-licensed component when distributed
separately ([JLA 2023](https://joinup.ec.europa.eu/licence/compatibility-check/BSD-3-Clause/Apache-2.0)).

MIT (INBOUND) is compatible with Apache-2.0 (OUTBOUND) for combined works but does not allow re-licensing of the
original MIT-licensed component when distributed
separately ([JLA 2023](https://joinup.ec.europa.eu/licence/compatibility-check/MIT/Apache-2.0)).

*Check out
the [JLA - Compatibility Checker](https://joinup.ec.europa.eu/collection/eupl/solution/joinup-licensing-assistant/jla-compatibility-checker) (
European Commission 2023).*

- **[beautifulsoup4](https://pypi.org/project/beautifulsoup4/)**\
  MIT ([LICENSE](https://pypi.org/project/beautifulsoup4/))

- **[cryptography](https://pypi.org/project/cryptography/)**\
  Apache-2.0 OR BSD-3-Clause ([LICENSE](https://github.com/pyca/cryptography/blob/main/LICENSE.APACHE))

- **[faiss-cpu](https://pypi.org/project/faiss-cpu/)**\
  MIT ([LICENSE](https://github.com/kyamagu/faiss-wheels/blob/main/LICENSE))

- **[fastapi](https://pypi.org/project/fastapi/)**\
  MIT ([LICENSE](https://github.com/tiangolo/fastapi/blob/master/LICENSE))

- **[httpx](https://pypi.org/project/httpx/)**\
  BSD-3-Clause ([LICENSE](https://github.com/encode/httpx/blob/master/LICENSE.md))

- **[ngrok](https://pypi.org/project/ngrok/)**\
  Apache-2.0 OR MIT ([LICENSE](https://github.com/ngrok/ngrok-python/blob/main/LICENSE-APACHE))

- **[pypdf](https://pypi.org/project/pypdf/)**\
  BSD-3-Clause ([LICENSE](https://github.com/py-pdf/pypdf/blob/main/LICENSE)

- **[requests](https://pypi.org/project/requests/)**\
  Apache-2.0 ([LICENSE](https://github.com/psf/requests/blob/main/LICENSE))

- **[sentence-transformers](https://pypi.org/project/sentence-transformers/)**\
  Apache-2.0 ([LICENSE](https://github.com/UKPLab/sentence-transformers/blob/master/LICENSE))

- **[toml](https://pypi.org/project/toml/)**\
  MIT ([LICENSE](https://github.com/uiri/toml/blob/master/LICENSE))

- **[torch](https://pypi.org/project/torch/)**\
  BSD-3-Clause ([LICENSE](https://github.com/pytorch/pytorch/blob/main/LICENSE))

- **[uvicorn](https://pypi.org/project/uvicorn/)**\
  BSD-3-Clause ([LICENSE](https://github.com/encode/uvicorn/blob/master/LICENSE.md))